local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/MapHeightRiverValley.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_c.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_Batavisium_2020",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -25,
	MaxHeight = 72,
	VillagePathList = {
		{
			Entrance = { 320, 0, 18 },
			Exit = { 320, 0, 18 }
		},
		{
			Entrance = { 540, 0, 1007 },
			Exit = { 540, 0, 1007 }
		},
		{
			Entrance = { 15, 0, 600 },
			Exit = { 15, 0, 600 }
		},
		{
			Entrance = { 1005, 0, 570 },
			Exit = { 1005, 0, 570 }
		},
	},
	SpawnList = {
		-- Hill NW 300 260
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 300, 8, 266 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 331, 10, 250 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 356, 9, 230 },
			Orientation = { 0.0, 10.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 290, 9, 290 },
			Orientation = { 0.0, 90.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 345, 13, 184 },
			Orientation = { 0.0, 110.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 301, 14, 151 },
			Orientation = { 0.0, 90.0, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 125, 15, 355 },
			Orientation = { 0.0, 20.0, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 215, 20, 304 },
			Orientation = { 0.0, -80.0, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 215, 38, 218 },
			Orientation = { 0.0, 80.0, 0.0 }
		},
		
		-- Hill SE 815 750
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 815, 7, 745 },
			Orientation = { 0.0, 220.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 796, 6, 751 },
			Orientation = { 0.0, 190.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 823, 5, 714 },
			Orientation = { 0.0, 210.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 851, 10, 716 },
			Orientation = { 0.0, 190.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 941, 27, 708 },
			Orientation = { 0.0, 190.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 892, 27, 736 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 912, 29, 736 },
			Orientation = { 0.0, 195.0, 0.0 }
		},

		-- Hill SW 285 690
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 292, 3, 712 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 270, 4, 704 },
			Orientation = { 0.0, 160.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 319, 5, 718 },
			Orientation = { 0.0, 150.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 342, 4, 719 },
			Orientation = { 0.0, 155.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 245, 4, 678 },
			Orientation = { 0.0, 50.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 251, 4, 694 },
			Orientation = { 0.0, 90.0, 0.0 }
		},

		-- Hill NE 825 110
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 852, 13, 107 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 835, 15, 101 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 820, 14, 96 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 817, 23, 75 },
			Orientation = { 0.0, 270.0, 0.0 }
		},


		-- Hill 985 260
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 981, 33, 259 },
			Orientation = { 0.0, 270.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 990, 38, 283 },
			Orientation = { 0.0, 280.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 990, 40, 235 },
			Orientation = { 0.0, 260.0, 0.0 }
		},

		-- Hill Middle 823 495
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 823, 8, 497 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 824, 8, 467 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 839, 10, 465 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 857, 12, 451 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 844, 12, 515 },
			Orientation = { 0.0, 270.0, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 91, 34, 685 },
			Orientation = { 0.0, 90.0, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 91, 32, 915 },
			Orientation = { 0.0, 90.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 45, 38, 789 },
			Orientation = { 0.0, 100.0, 0.0 }
		},
	},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.88,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.93,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})